﻿using MotorPlantContracts.BindingModels;
using MotorPlantContracts.SearchModels;
using MotorPlantContracts.StoragesContracts;
using MotorPlantContracts.ViewModels;
using MotorPlantDatabaseImplement.Models;

namespace MotorPlantDatabaseImplement.Implements
{
	public class MessageInfoStorage : IMessageInfoStorage
	{

			public List<MessageInfoViewModel> GetFullList()
			{
				using var context = new MotorPlantDatabase();
				return context.MessageInfos.Select(x => x.GetViewModel).ToList();
			}
			public List<MessageInfoViewModel> GetFilteredList(MessageInfoSearchModel model)
			{
				if (!model.ClientId.HasValue)
				{
					return new();
				}
				using var context = new MotorPlantDatabase();
				return context.MessageInfos.Where(x => x.ClientId.HasValue && x.ClientId == model.ClientId).Select(x => x.GetViewModel).ToList();
			}
			public MessageInfoViewModel? GetElement(MessageInfoSearchModel model)
			{
				if (string.IsNullOrEmpty(model.MessageId))
				{
					return new();
				}
				using var context = new MotorPlantDatabase();
				return context.MessageInfos.FirstOrDefault(x => x.MessageId == model.MessageId)?.GetViewModel;
			}
			public MessageInfoViewModel? Insert(MessageInfoBindingModel model)
			{
				var newMessage = MessageInfo.Create(model);
				if (newMessage == null)
				{
					return null;
				}
				using var context = new MotorPlantDatabase();
				context.MessageInfos.Add(newMessage);
				context.SaveChanges();
				return newMessage.GetViewModel;
			}
		}
	}

