﻿using MotorPlantContracts.BindingModels;
using MotorPlantContracts.ViewModels;
using MotorPlantDataModels.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace MotorPlantDatabaseImplement.Models
{
	public class MessageInfo : IMessageInfoModel
	{
		[Key]
		[DatabaseGenerated(DatabaseGeneratedOption.None)]
		public string MessageId { get; set; } = string.Empty;

		public int? ClientId { get; set; }

		public virtual Client? Client { get; set; }

		[Required]
		public string SenderName { get; set; } = string.Empty;

		[Required]
		public DateTime DateDelivery { get; set; }

		[Required]
		public string Subject { get; set; } = string.Empty;

		[Required]
		public string Body { get; set; } = string.Empty;

		public static MessageInfo? Create(MessageInfoBindingModel? model)
		{
			if (model == null)
			{
				return null;
			}
			return new()
			{
				MessageId = model.MessageId,
				ClientId = model.ClientId,
				SenderName = model.SenderName,
				DateDelivery = model.DateDelivery,
				Subject = model.Subject,
				Body = model.Body,

			};
		}

		public MessageInfoViewModel GetViewModel => new()
		{
			MessageId = MessageId,
			ClientId = ClientId,
			SenderName = SenderName,
			DateDelivery = DateDelivery,
			Subject = Subject,
			Body = Body
		};
	}
}